﻿Type=Class
Version=2.71
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private mTarget As Object
	Private mEventName As String
	Private holder As Panel

	Dim GD As GestureDetector
	Dim pnl As Panel
	Dim Cvs As Canvas
	
	Type Center(x As Float, y As Float)
	Dim Point(9) As Center
	Dim Radius As Float = 40dip
	Dim PointSelected As String
	Dim LastPoint As Int
	Dim DigitLen As Int = 5
			
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize (Target As Object, EventName As String)
	mTarget = Target
	mEventName = EventName
	
	If SubExists(mTarget, mEventName & "_Closed") = False Then
		ToastMessageShow("There is no " & mEventName & "_Closed", False)
		Return
	End If

End Sub

Public Sub AddView(Parent As Activity, Left As Int, Top As Int, Width As Int, Height As Int)
		
	holder.Initialize("holder")
	Hide_holder
	holder.Color = Colors.ARGB(102, 0, 0, 0)
	Parent.AddView(holder, 0, 0, 100%x, 100%y)
	
	pnl.Initialize("")
	pnl.Color = Colors.white
	holder.AddView(pnl, Left, Top, Width, Height)
	
	GD.SetOnGestureListener(pnl, "Gesture")
	GD.EnableLongPress(False)
	
	Dim CenterPoint As Center
	CenterPoint.Initialize
	Dim minDim As Float = Min(pnl.Width,pnl.Height)
	
	CenterPoint.x = .5 * pnl.Width
	CenterPoint.y = .5 * pnl.Height
	Dim Offset As Float = .3 * minDim
	Radius = .1 * minDim
	Dim Offset As Float = .3 * minDim
	
	Radius = .1 * pnl.Width
	For i = 0 To Point.Length-1
		Point(i).Initialize
	Next
	
	Point(0).x = CenterPoint.x - Offset
	Point(0).y = CenterPoint.y - Offset
	Point(1).x = CenterPoint.x
	Point(1).y = CenterPoint.y - Offset
	Point(2).x = CenterPoint.x + Offset
	Point(2).y = CenterPoint.y - Offset
	Point(3).x = CenterPoint.x - Offset
	Point(3).y = CenterPoint.y
	Point(4).x = CenterPoint.x
	Point(4).y = CenterPoint.y
	Point(5).x = CenterPoint.x + Offset
	Point(5).y = CenterPoint.y
	Point(6).x = CenterPoint.x - Offset
	Point(6).y = CenterPoint.y + Offset
	Point(7).x = CenterPoint.x
	Point(7).y = CenterPoint.y + Offset
	Point(8).x = CenterPoint.x + Offset
	Point(8).y = CenterPoint.y + Offset
			
	Cvs.Initialize(pnl)
		
End Sub

Public Sub Show

	PointSelected = ""
	Cvs.DrawColor(Colors.White)
	For i = 0 To Point.Length-1
		Cvs.DrawCircle(Point(i).x, Point(i).y, Radius, Colors.Green, False, 3dip)
	Next
	pnl.Invalidate
	
	holder.Visible = True
End Sub

Private Sub Hide_holder
	holder.Visible = False
End Sub

Sub WithInPoint(x As Float, y As Float)
	Dim a As Float
    Dim b As Float
	Dim c As Float
	If PointSelected.Length < DigitLen Then
		For i = 0 To Point.Length - 1
			a = Point(i).x - x 
			b = Point(i).y - y
			c = Sqrt(a * a + b * b)
			If c < Radius Then
				Dim NewPoint As Int = i+1
				If LastPoint <> NewPoint Then
					PointSelected = PointSelected & NewPoint
					'Log("Selected: " & PointSelected)
					'Log("Point: " & NewPoint)
					If PointSelected.Length > 1 Then
						Dim S As Int = LastPoint - 1
						Dim E As Int = NewPoint - 1
						Cvs.DrawLine(Point(S).x, Point(S).y , Point(E).x,Point(E).y, Colors.Red, 5dip)
						pnl.Invalidate
					End If
					LastPoint = NewPoint
					Exit
				End If
			End If
		Next
	Else
		Log("Selected: " & PointSelected)
'		holder.RemoveView
		Hide_holder
		CallSub3(mTarget, mEventName & "_Closed", False, PointSelected)
	End If
End Sub

Sub Gesture_onTouch(Action As Int, X As Float, Y As Float, MotionEvent As Object)
	Log("onTouch action=" & Action & ", x=" & X & ", y=" & Y & ", ev=" & MotionEvent)
'	If holder.NumberOfViews > 0 Then
	If holder.visible Then
		WithInPoint(X,Y)
	End If
End Sub
